/*
 *  Copyright 2010 Anyware Services
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

Ext.namespace('org.ametys.odf.sync.widgets');

// Register widget
org.ametys.utils.Widgets.registerWidget ('string', 'empty', 'org.ametys.odf.sync.widgets.EmptyField');
org.ametys.utils.Widgets.registerWidget ('boolean', 'empty', 'org.ametys.odf.sync.widgets.EmptyField');
org.ametys.utils.Widgets.registerWidget ('date', 'empty', 'org.ametys.odf.sync.widgets.EmptyField');
org.ametys.utils.Widgets.registerWidget ('long', 'empty', 'org.ametys.odf.sync.widgets.EmptyField');
org.ametys.utils.Widgets.registerWidget ('double', 'empty', 'org.ametys.odf.sync.widgets.EmptyField');
org.ametys.utils.Widgets.registerWidget ('rich_text', 'empty', 'org.ametys.odf.sync.widgets.EmptyField');

org.ametys.odf.sync.widgets.EmptyField = function(config) 
{
	config.name = config.name + '_empty';
	
	org.ametys.odf.sync.widgets.EmptyField.superclass.constructor.call(this, config);
}; 

Ext.extend(org.ametys.odf.sync.widgets.EmptyField, Ext.form.Hidden, {});

org.ametys.odf.sync.widgets.EmptyField.prototype.onRender = function (ct, position)
{
	// Unregister field from html areas if exists
	var toolPanel = this.findParentBy (function (ct, cmp) { return ct.tool != null});
	if (toolPanel != null)
	{
		var htmlAreas = toolPanel.tool._htmlAreas;
		if (htmlAreas != null && htmlAreas.indexOf(this.id) != -1)
		{
			htmlAreas.remove(this.id);
		}
	}
	
	org.ametys.odf.sync.widgets.EmptyField.superclass.onRender.call(this, ct, position);
}

org.ametys.odf.sync.widgets.EmptyField.prototype.setValue = function(values) 
{
	org.ametys.odf.sync.widgets.EmptyField.superclass.setValue.call(this, values);
	
	if (this.copyValueTo)
    {
	    var form = org.ametys.odf.sync.widgets.SynchronizedWidgetHelper._getForm(this);
	    form.el.dom.elements[this.copyValueTo].value = values;
    }
};
